Page MenuHomePhabricator

Add a download on WiFi only setting for reading list users
Closed, ResolvedPublic2 Story Points

Description

This is likely to be more pertinent as users start being able to add to reading lists from desktop browsers and multiple devices, for example, as seen in this OTRS report: https://ticket.wikimedia.org/otrs/index.pl?Action=AgentTicketZoom;TicketID=10661383

User story

As a reading list user who wants to conserve data usage, I want to be able to stop downloading synced articles to my device when so that I do not waste mobile data.

Proposed solution

Add a setting to the "Data usage" section of the app which enables users to "Download only over Wi-Fi".

Steps to QA

A. Articles on reading lists download only when WiFi is on
  1. Go to Settings and enable "Download only on WiFi" setting
  2. Turn off WiFi
  3. Go to any article and save to a reading list. It is *expected* the article will not be downloaded since WiFi is unavailable.
  4. Turn WiFi on. It is *expected* the article will be download since WiFi is turned back on.
B. Article downloading using data can be overridden manually
  1. Go to Settings and enable "Download only on WiFi" setting
  2. Turn off WiFi
  3. Go to any article and save to a reading list. It is *expected* the article will not be downloaded since WiFi is unavailable.
  4. Go to the reading list where the article was saved. Tap on the "downloading in progress" icon for that article. It is *expected* a dialog will appear asking if the user wants to proceed with downloading using mobile data.
  5. If user selects 'yes', the article will be downloaded with mobile data.

Event Timeline

RHo created this task.Apr 25 2018, 2:53 PM
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptApr 25 2018, 2:53 PM
RHo updated the task description. (Show Details)Apr 30 2018, 7:15 PM

Hi, @RHo

Does this "Data usage" section has any description text for it?

RHo added a comment.EditedMay 24 2018, 8:17 PM

hi @cooltey - let's can just add the setting without a description, seems pretty straightforward:

(note I updated the verbiage though to "Download only over Wi-Fi"

Sounds good, thanks.

cooltey updated the task description. (Show Details)May 24 2018, 9:16 PM
TheDJ added a subscriber: TheDJ.May 24 2018, 9:29 PM

You can register a BroadcastReceiver for the app for notification of the wifi state, to automatically resume download when you are back on wifi. just a thought.

@TheDJ That's good! Thanks for sharing your idea.

Change 435065 had a related patch set uploaded (by Cooltey; owner: Cooltey):
[apps/android/wikipedia@master] [WIP] Download only over WiFi

https://gerrit.wikimedia.org/r/435065

Hi @RHo, I have the following questions (the patch is not merged yet)

Question 1
When the state of Download only over Wi-Fi is ON, which icon should the app show to users?
The downloading in progress icon?


or the available to download icon on each article?

or... new icon?

Question 2
When the state of Download only over Wi-Fi is ON, should it be available for users to do the download the article action manually by clicking on the download icon or save all for offline?

RHo added a comment.May 29 2018, 6:45 PM

Hi @RHo, I have the following questions (the patch is not merged yet)
Question 1
When the state of Download only over Wi-Fi is ON, which icon should the app show to users?
The downloading in progress icon?


or the available to download icon on each article?

or... new icon?

  • hi @cooltey - the expectation is that the download will resume when the user is on Wi-Fi, so let's keep it as the downloading in progress icon. Thanks!

Question 2
When the state of Download only over Wi-Fi is ON, should it be available for users to do the download the article action manually by clicking on the download icon or save all for offline?

  • If the user has explicitly tapped the 'Download icon' or 'Save all for offline' even with this setting, can we show a dialog where they can choose to allow/cancel downloading using mobile data? Ie. something like this:

Change 441092 had a related patch set uploaded (by Dbrant; owner: Dbrant):
[apps/android/wikipedia@master] Follow-up to Wi-Fi download setting.

https://gerrit.wikimedia.org/r/441092

Change 435065 merged by jenkins-bot:
[apps/android/wikipedia@master] Add a download on WiFi only setting for reading list users

https://gerrit.wikimedia.org/r/435065

Change 441092 merged by jenkins-bot:
[apps/android/wikipedia@master] Follow-up to Wi-Fi download setting.

https://gerrit.wikimedia.org/r/441092

Vvjjkkii renamed this task from Add a download on WiFi only setting for reading list users to g9daaaaaaa.Jul 1 2018, 1:14 AM
Vvjjkkii removed cooltey as the assignee of this task.
Vvjjkkii raised the priority of this task from Normal to High.
Vvjjkkii removed the point value for this task.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii edited subscribers, added: cooltey; removed: gerritbot, Aklapper.
Sharvaniharan renamed this task from g9daaaaaaa to Add a download on WiFi only setting for reading list users.Jul 1 2018, 5:02 AM
Sharvaniharan assigned this task to cooltey.
Sharvaniharan lowered the priority of this task from High to Normal.
Sharvaniharan set the point value for this task to 2.
Sharvaniharan updated the task description. (Show Details)
Sharvaniharan added subscribers: Aklapper, gerritbot.
RHo updated the task description. (Show Details)Aug 2 2018, 4:32 PM

Hi @cooltey – the setting works but I'm not seeing the dialog to allow mobile data downloading as detailed in scenario B (see updated task description).

Expected: F18600475Actual:
incorrect toast message saying that the article download is in progress.

Hi @RHo, I have the following questions (the patch is not merged yet)
Question 2
When the state of Download only over Wi-Fi is ON, should it be available for users to do the download the article action manually by clicking on the download icon or save all for offline?

  • If the user has explicitly tapped the 'Download icon' or 'Save all for offline' even with this setting, can we show a dialog where they can choose to allow/cancel downloading using mobile data? Ie. something like this:

Thanks, @RHo

The dialog shows when the status of the article is not in "OFFLINE". We'll need to do Remove from offline and then try to click the download icon again to trigger the alert dialog of using mobile data.

I will add another logic that if the download is processing and click on the downloading icon will do the forced download.

Change 450166 had a related patch set uploaded (by Cooltey; owner: Cooltey):
[apps/android/wikipedia@master] Tweak: add a download on WiFi only setting for reading list users

https://gerrit.wikimedia.org/r/450166

Change 450166 merged by jenkins-bot:
[apps/android/wikipedia@master] Tweak: add a download on WiFi only setting for reading list users

https://gerrit.wikimedia.org/r/450166

Restricted Application changed the subtype of this task from "Deadline" to "Task". · View Herald TranscriptAug 30 2018, 8:25 PM
Dbrant closed this task as Resolved.Nov 1 2018, 5:21 PM